package cs297.xmldb.src.bm;

import java.io.*;
import java.util.*;
import java.lang.*;
import cs297.xmldb.src.server.*;
import cs297.xmldb.src.cm.*;
/**
 * This is interface for ThPage and ThPageInterpreter
 * Date: Spring 2004
 * @author: Thien An Nguyen, 
 */
public interface IThPage{
  public int getPageNum();
  public String createInsertLogRecord(String rectype, String txid,
                              int id, String path, ArrayList values,  
                              String xmlname, String dbname,
                              ThSystem sys);
  public String createDelLogRecord(String rectype, String txid,
                              int id, String path,   
                              String xmlname, String dbname, ThSystem sys);
  public String createUpdateLogRecord(String rectype, String txid,
             int id, String path, String oldvalue, String newvlue,
             String xmlname, String dbname, ThSystem sys);
  public int insert(String msg, String txid, int id, String path,
                    ArrayList value, String xmlname, String dbname,
                    boolean group, ThSystem sys, boolean natixlog, 
                    boolean islog);
  public int insert(IThNode node, int parentid, ThSystem sys);
  public int insert(IThNode newstructednode, IThNode prev, ThSystem sys);
  public String update(int id, String data, String lsn, ThSystem sys);
  public int getOffset(int id);
  public ArrayList getData(int id);
  public boolean isFull(int length);
  public char[] toHex();
  public int getSize();
  public IThNode remove(int id);
  public void removeSubTree(ThGroup node);
  public int getNodeCount();
  public IThNode getNodeByOffset(int idx);
  public void publicLogsToLM(ThSystem sys);
  public void split(IThPage newpage, int id, Stack stack, ThSystem sys);
  public void add(IThNode node);
  public void addSubTree(ThGroup node);
  public void updateFreeSpace(int datalength);
}
