package cs297.xmldb.src.Client;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import java.util.*;
import javax.swing.border.*;
import cs297.xmldb.src.cm.*;

/**
 * Client application that connect to specified server.
 * @author: Thien An Nguyen, 
 */
public class ThClientGUI extends JFrame implements ActionListener, ItemListener{
  int TIME_OUT = 500;
  int PORT = 1500;
//  InetAddress host = InetAddress.getLocalHost();
  private JButton okButton,
                  cancelButton,
  		  closeButton;

  Socket socket = null;

//  private JComboBox cityCombobox;
  ObjectInputStream in = null;
  ObjectOutputStream out = null;

  public ThClientGUI(String title){
    super(title);
    //handle windows close	
    addWindowListener(new WindowAdapter(){  
    public void windowClosing(WindowEvent e){  
      System.exit(0);
    }
    } );

    //init socket connection
/*    socket = ThConnectionMgr.openSocket(host, PORT, TIME_OUT);
    if(socket == null){
      JOptionPane.showMessageDialog(null, 
                                    "Please check host again!",
			            "Error!", JOptionPane.ERROR_MESSAGE);						 					"Error!", JOptionPane.ERROR_MESSAGE);
    }                                    
*/
    //if connection is confirmed, init GUI for client.
    initGui();		
  }
    
  public void actionPerformed(ActionEvent evt){
    try{			
      Object source = evt.getSource();
      if(source == okButton){	
        JOptionPane.showMessageDialog(null, 
                                    "Not implement Yet!", 
				    "Error!", JOptionPane.ERROR_MESSAGE);
        validate();
      } else if (source == cancelButton){
        //do nothing
      } else if (source == closeButton){
        System.exit(0);
      }			
    }catch (Exception e){
      JOptionPane.showMessageDialog(null, 
                                    "Cannot connect to the server!", 
				    "Error!", JOptionPane.ERROR_MESSAGE);
      return;
    }
  }

  public void close(){
    try{
      out.close();
      in.close();
      socket.close();		
    }catch (IOException e){
      System.out.println("ThClientSocket: "+ e);
    }
  }

  public void initGui(){
    Border etched = BorderFactory.createEtchedBorder();
    JPanel p1 = new JPanel();
    p1.setPreferredSize(new Dimension(450, 300));
    p1.setBorder(etched);

    //buttons
    okButton = new JButton("Ok");
    okButton.addActionListener(this);
    cancelButton = new JButton("Cancel");		
    cancelButton.addActionListener(this);
    closeButton = new JButton("Close");
    closeButton.addActionListener(this);
                
    JPanel p3 = new JPanel();
    p3.setSize(new Dimension(450, 30));
    p3.add(okButton);
    p3.add(cancelButton);
    p3.add(closeButton);
    
    Box b = Box.createVerticalBox();
    b.add(p1);
    b.add(p3);
    
    getContentPane().add(b);
    pack();
  }
  
  public void itemStateChanged( ItemEvent event ){
  }

  public static void main(String[] args){
    JFrame frame = new ThClientGUI("Client");
    frame.show();
  }
}
