package cs297.xmldb.src.cm;
import java.io.*;
import java.util.*;
import java.lang.*;
import cs297.xmldb.src.bm.*;
import cs297.xmldb.src.sm.*; 
import cs297.xmldb.src.server.*;

/**
 * @Date: Spring & fall 2004
 * @author: Thien An Nguyen, 
 * @Purpose: logical Attribute node 
 */
 public class ThAttributeNode implements Serializable{
 public String tag; //tagid
 public String data; //dataid
 boolean deleted;
 
 public ThAttributeNode(String tg, String dat) 
 {
    tag = tg;
    data = dat;
    deleted = false; 
 }
 
 /**
  Constructor that create an atribute object from a byte
  array of HEX characters.
  @param: byte array,
          position to start decoding
  */
 public ThAttributeNode(byte[] arr, int offset)
 {
    /* 2bytes len */
    int pos = offset;
    int len = ThUtilities.hexToNumber(arr, pos);
    pos += 4;   
    /* ag data */
    tag = ThUtilities.hexToData(arr, pos, len);   
    pos += len*2;
   
    /* 2bytes len */
    len = ThUtilities.hexToNumber(arr, pos);
    pos += 4;
   
    /* tag data */
    data = ThUtilities.hexToData(arr, pos, len);
    deleted = false; 
 }
 
 public String getTag()
 {
    return tag;
 }
 
 public String getData()
 {
    return data;
 }
 
 public boolean isDeleted()
 {
    return deleted;
 }

 public void setDeleted(boolean val)
 {
   deleted = val;
 }

 public int size()
 {
    return 4 + (tag.length() *2) + 4 + (data.length() *2) + 1; 
 }
 
 /**
  Convert the in memmory version of this object into
  an array of hex characters
  @Receive: The character array and the offset where this
           object can be started.
  @Returns: Return Code.
  */
 public int toHex(char[] arr, int offset)
 {
    int pos = offset;
   
    //2 bytes the length of tag
    int len = tag.length();   
    pos += ThUtilities.numberToHex(arr, len, pos);
   
    //tag
    pos += ThUtilities.dataToHex(arr, tag, pos);
   
    //2 bytes the length of data
    len = data.length();   
    pos += ThUtilities.numberToHex(arr, len, pos);  
   
    // data 
    pos += ThUtilities.dataToHex(arr, data, pos);

    return pos - offset; //data length
 }
}
