package cs297.xmldb.src.cm;
import java.io.*;
import java.util.*;
import java.lang.*;

/**
 This is general purpose node that is used in ThPage,
 ThPageInterpreter, ThSpaceMapPage classes for the 
 in memory version of the page.
 @Date: Spring 2004
 @author: Thien An Nguyen, 
 */
public class ThNode implements IThNode
{
   int iD;
   ArrayList datA; //leave data or attr & data
   BitSet inFo;
  
  public ThNode(int id, boolean isGroup, ArrayList data)
  {
     iD = id;
     inFo = new BitSet(8);
     inFo.set(7, isGroup); //group or leave
     inFo.set(6, false);  //deleted or not
     datA = data;
  } 
  
  public boolean isGroup()
  {
     return inFo.get(7);
  }
  
  public BitSet getInfoByte()
  {
     return inFo;
  }
  
  public ArrayList getData()
  {
     return datA;
  }
  
  public void addData(String data)
  {
     datA.add(data);
  } 
  
  public boolean isDeleted()
  {
     return inFo.get(6);
  }
  
  public void setDeleted(boolean val)
  {
     inFo.set(6, val);
  }  
  
  public int getId()
  {
    return iD;
  }
  
  /** 
   Compute the size of this node.
   This function is used most when this node is need 
   to be added in a some kind of page.
   @Receive: nothing
   @Returns: the size of data in this node.
   */
  public int size()
  {
     int total = 0;

     for (int i=0; i<datA.size(); i++) // length of data follows by data 
        total += ((((String) datA.get(i)).length())*2); 
    
     return total;
  }
  
  public IThNode getChild(int idx) 
  {
     return null;
  }
  
  public ArrayList getChildren() 
  {
     return null;
  }
  
  public int getChildrenCount() 
  {
     return -1;
  }
  
  public boolean hasData() 
  {
     return true;
  }
  
  public void insert(IThNode node) 
  {
  }
  
  public int toHex(char[] arr, int offset) 
  {
     return -1;
  }
  
  public int toHex(char[] arr, int offset, int pos) 
  {
     return -1;
  }
  
  public void upDate(String val)
  {
     datA.remove(0);
     datA.add(0, val);
  }
  
  public int getPageNum() 
  {
     return -1;
  }
  
  public boolean isMatch(String key) 
  {
     return false;
  }
}
