package cs297.xmldb.src.cm;

import java.io.*;
import java.util.*;
import java.lang.*;
import cs297.xmldb.src.server.*;

/**
 A proxy node is a node that point to other nodes
 that is not on the same page as the original.
 Date: Spring 2004
 @author: Thien An Nguyen, 
 */
public class ThProxyNode extends AThNode //implements IThNode
{
   IThNode node;
   int pageNum;
   
 public ThProxyNode(int id, int pagenum)
 {
    super(id);
    pageNum = pagenum;
 }
 
  public ThProxyNode(int id, byte[] arr, int offset)
  {
     super(id);
     
     final int BYTE4 = 4;
     int len = 0;
     String data = "";
     int childcount = 0;
    
     int pos = offset;   /* get local copy of offset */
     
     /* decode page number */
     len = ThUtilities.hexToNumber(arr, pos);
     pos += BYTE4; //len of tag
     data = ThUtilities.hexToData(arr, pos, len);
     pos += len;
     pageNum = Integer.parseInt(data);
  }  
  
 /**
  convert in memmory structure of this node
  to a sequence of byte array on a disk block/chunck 
  @Receive: the disk block, and offset for this node.
  @Returns: Return Code
  */
  public int toHex(char[] arr, int offset)
  {
     int pos = offset;
     int len = 0;
     String data = "";
     
     /* Group or Leave node. 1 for G. 0 otherwise */
     BitSet byt = new BitSet(); 
     byt.set(7);    /* 7 - Proxy, 6 - Group, other wise - Leave*/
     pos += ThUtilities.BitsetToChar(arr, byt, pos); 
     
     /* page num */
     data = Integer.toString(pageNum);
     pos += ThUtilities.numberToHex(arr, data.length()*2, pos);
     pos += ThUtilities.dataToHex(arr, data, pos);
     
     return pos - offset;
  }  
  
 public int getId()
 {
    return super.getId();
 }
 
 public int getPageNum()
 {
    return pageNum;
 }
 
 public boolean hasChild()
 {
    return false;
 }
 
 public void setChildPtr(int idx)
 {
 }
 
 public int getChildPtr() 
 {
   return -1;   // no more child 
 }
 
 public boolean hasNext()
 {
    return false;
 }
 
 public void setNextPtr(int pnum)
 {
    //  nodeInfo.set(4);
 }
 
 public int getNextIdx()
 {
    return -1;
 }
 
 public void insert(IThNode node)
 {
 }
 
 public String toString(ThSystem sys)
 {
    /*   ThBufferMgr bm = sys.getBM();
    IThPage page = bm.getPage(pageNum, sys);
    return page.getData(Integer.toString(iD));     */
    return "";
 }

 public boolean hasData()
 {
    return false;
 }
 
 public boolean isDeleted() 
 {
    return false;
 }
 
 public void setDeleted(boolean val) 
 {
 }
 
 public IThNode getChild(int idx) 
 {
    return null;
 }
 
 public int size()
 { //2bytes offset + size data (pnum)
    return super.size() + 4 + (Integer.toString(pageNum)).length()*2;
 }
 
 public ArrayList getChildren() 
 {
    return null;
 }
 
 public int getChildrenCount() 
 {
    return -1;
 }
 
 public int toHex(char[] arr, int offset, int idoffset) 
 {
    return -1;
 }
 
 public boolean isGroup() 
 {
    return false;
 }
 
 public void upDate(String val) 
 {
 }
 
 public boolean isMatch(String key) 
 {
    return false;
 } 
}
