package cs297.xmldb.src.cm;

import java.io.*;
import java.util.*;
import java.lang.*;
import cs297.xmldb.src.server.*;

/**
 * Date: Spring 2004
 * @author: Thien An Nguyen, 
 */
public class ThStrucNode implements IThNode
{
   BitSet nodeInfo; //.5 byte
   IThNode nodE;
   int childPtr = -1;  //with this number, * sizeof id node (fixed) => offset
   int nextPtr = -1;
   
 public ThStrucNode(IThNode node)
 {
    nodE = node;
    nodeInfo = new BitSet();
    nodeInfo.set(2); //data node
    if (node.getClass().getName().indexOf("ThGroup") >= 0)
       nodeInfo.set(7);
   
    childPtr = -1;
    nextPtr = -1;
    // the rest of the information will be set
    // as next node is added
 }
 
 public int getId()
 {
    return nodE.getId();
 }
 
 public boolean hasChild()
 {
    return nodeInfo.get(5);
 }
 
 public void setChildPtr(int ptr)
 {
    childPtr = ptr;
    nodeInfo.set(3);
 }
 
 public int getChildPtr() 
 {
    return childPtr;   // no more child 
 }
 
 public boolean hasNext()
 {
    return nodeInfo.get(4);
 }
 
 public void setNextPtr(int ptr)
 {
    nextPtr = ptr;
    nodeInfo.set(4);
 }
 
 public int getNextPtr()
 {
    return nextPtr;
 }
 
 public void insert(IThNode node)
 {
 }
 
 public String toString()
 {
    String data = "";
    data += Integer.toString(getId());
   
    return data;
 }
 
 public int toHex(char[] arr, int offset)
 {
    return -1;
 } 
 
   /**
   * @Purpose: convert this node in memory to a 
   *          hex character array that can be store on disk.
   * @Receive: the disk block, the offset for data part,
   *          and the offset for the header node part.
   */
 public int toHex(char[] arr, int offset, int idoffset)
 {
    int idpos = idoffset;
    int datapos = offset;
    //id, offset to data within the page, ptr child, ptr next (idx of that node in)
    idpos += ThUtilities.numberToHex(arr, getId(), idpos);
    idpos += ThUtilities.BitsetToChar(arr, nodeInfo, idpos); 
   
    if (nodE.getClass().getName().indexOf("ThGroup") >= 0)
    {
       ThAttributeNode atnode = ((ThGroup)nodE).getAttributeNode();
       datapos += atnode.toHex(arr, datapos);
    } 
    else  //leave node
       datapos += ((ThLeave) nodE).toHex(arr, datapos);
   
    idpos +=ThUtilities.numberToHex(arr, childPtr, idpos);
    idpos +=ThUtilities.numberToHex(arr, nextPtr, idpos);
   
    return datapos - offset; //length of datanode
 }
 
 public boolean hasData() 
 {
    return false;
 }
 
 public boolean isDeleted() 
 {
    return nodE.isDeleted();
 }
 
 public void setDeleted(boolean val) 
 {
 }
 
 public IThNode getChild(int idx) 
 {
    return null;
 }
 
 public int size() 
 {
    return 1 + nodE.size() + 4 + 4;
 }
 
 public ArrayList getChildren() 
 {
    return null;
 }
 
 public int getChildrenCount() 
 {
    return -1;
 }
 
 public boolean isGroup() 
 {
    return nodeInfo.get(7);
 }
 
 public void upDate(String val) 
 {
 }
 
 public int getPageNum() 
 {
    return -1;
 }
 
 public boolean isMatch(String key) 
 {
    return false;
 }
}
