package cs297.xmldb.src.sm;
import java.io.*;
import java.util.*;
import java.lang.*;
import cs297.xmldb.src.cm.*;
import cs297.xmldb.src.bm.*;
import cs297.xmldb.src.server.*;
import cs297.xmldb.src.sm.*;

/**
 COPYRIGHT (C) 2004 Thien An Nguyen. All Rights Reserved.
 This class contains global variables such as system
 catalog (where to search for created databases,...
 @Date: Spring 2004
 @author: Thien An Nguyen, 
 */
public class ThLogRecord implements Comparable
{
  String logType;
  String pNum;
  String txId;
  String offSet;
  ArrayList oldVal;
  ArrayList newVal;
  String iD;
  String lsN; 
  String xmlName;
  String dbName;
  String patH;
  
  public ThLogRecord(String logtype, String lsn, String pnum, String txid,  
                     String id, String path, String oldval, String newval, 
                     String xmlname, String dbname)
  {
     logType = logtype;
     pNum = pnum;
     txId = txid;
     patH = path;
     oldVal = new ArrayList();
     oldVal.add(oldval);
     newVal = new ArrayList();
     newVal.add(newval);
     iD = id;
     lsN = lsn; 
     xmlName = xmlname;
     dbName = dbname;    
  }
  
  public ThLogRecord(String logtype, String lsn, String pnum, String txid,  
                     String id, String path, String newval, 
                     String xmlname, String dbname)
  {
     logType = logtype;
     pNum = pnum;
     txId = txid;
     patH = path;
     newVal = new ArrayList();
     newVal.add(newval);
     iD = id;
     lsN = lsn; 
     xmlName = xmlname;
     dbName = dbname;    
  }  
  
  public ThLogRecord(String logtype, String lsn, String pnum, String txid,  
                     String id, String path, ArrayList newval, 
                     String xmlname, String dbname)
  {
     logType = logtype;
     pNum = pnum;
     txId = txid;
     patH = path;
     newVal = newval;
     iD = id;
     lsN = lsn; 
     xmlName = xmlname;
     dbName = dbname;    
  }  
    
  
  public String getLogType()
  {
     return logType;
  }
  
  public String getLSN()
  {
     return lsN;
  }  
  
  public String getId()
  {
     return iD;
  }
  
  public String getXmlName()
  {
     return xmlName;
  }
  
  public String getDbName()
  {
     return dbName;
  }
  
  public String getOldValue()
  {
     return (String) oldVal.get(0);
  }
  
  public ArrayList getOldValues()
  {
     return oldVal;
  }  
  
  public String getNewValue()
  {
     return (String) newVal.get(0);
  }  
  
  public ArrayList getNewValues()
  {
     return newVal;
  }  
  
  public String getPageNum()
  {
     return pNum;
  }
  
  public String getOffset()
  {
     return offSet;
  }
  
  public String toString()
  {
     return lsN+" "+iD+" "+oldVal+" "+newVal+" "+xmlName+" "+dbName;
  }
  
  public String getPath()
  {
     return patH;
  }
  
  public String getTxId()
  {
     return txId;
  }
  
  public void addLeave(String leaveval)
  {
     newVal.add(leaveval);
  }
  
  /**
   This function defines the order of the log records we want to sort
   @param: the object (another log record) to be compare with
   @return: 0 if they are equals,
            -1 if this object is less than the obj
            1 if this object is greater than the obj object.
   */
  public int compareTo(Object obj) 
  {
     ThLogRecord log = (ThLogRecord) obj;
     int result = lsN.compareTo(log.getLSN());
     if (result < 0)
        return 1;
     else if (result > 0)
        return -1;
     return result;       
  }  
}