package cs297.xmldb.src.sm;
import java.io.*;
import java.util.*;
import java.lang.*;
import cs297.xmldb.src.cm.*;
import cs297.xmldb.src.bm.*;
import cs297.xmldb.src.server.*;
/**
 COPYRIGHT (C) 2004 Thien An Nguyen. All Rights Reserved. 
 @Date: Spring 2004
 @author: Thien An Nguyen, 
 */
public class ThStorageMgr
{
  String storageDir;
  
  public ThStorageMgr(Properties properties)
  {
     storageDir = properties.getProperty("storageDirectory");
  }
  
  /**
   This function handles the file openning. 
   It also call appropreate page 
   */
  public IThPage loadPage(String pagenum, int size, ThSystem sys)
  {    
     String physicalID = storageDir+pagenum+".page";
     byte[] inhex = new byte[size];
    
     try
     {
        DataInputStream inStream = new DataInputStream(
                                  new BufferedInputStream(
                                  new FileInputStream(physicalID)));     

       int len = inStream.read(inhex);   
       if (sys.isNatix())
          return (IThPage) new ThPageInterpreter(len, inhex);
      
       return (IThPage) new ThPage(len, inhex);
     }
     catch(Exception e)
     {
        e.printStackTrace();
        return null;
     }     
  }
  
  public String flushPage(IThPage page)
  {  
     int size = page.getSize();
     String pagenum = Integer.toString(page.getPageNum());
     String physicalID = storageDir+pagenum+".page";
    
     try
     {
        File file = new File(physicalID);
      
        if (file.exists())
          file.delete();
      
        DataOutputStream outStream = new DataOutputStream(
                                   new BufferedOutputStream(
                                   new FileOutputStream(physicalID)));
        char[] hex = page.toHex();
        String str = new String(hex);
        outStream.writeBytes(str);
        outStream.close();
        //also give a viewable verstion of this page
        printPage(size, physicalID, hex);
     }
     catch(Exception e)
     {
        e.toString();
        return null;
     }     
     return physicalID;  //success
  }
  
  public void printPage(int size, String fname, char[] hex)
  {    
     fname += "formated";
     try
     {
        File file = new File(fname);
      
        if (file.exists())
          file.delete();
      
        DataOutputStream outStream = new DataOutputStream(
                                   new BufferedOutputStream(
                                   new FileOutputStream(fname)));
        for (int i = 0; i < hex.length; i++)
        {
            if (i > 0 && i % 40 == 0)
               outStream.writeBytes("\r\n");
            outStream.writeChar(hex[i]);
        }
        outStream.close();
     }
     catch(Exception e)
     {
        e.toString();
     }  
  }
  
  public void freePage(IThPage page)
  {  
     String pagenum = Integer.toString(page.getPageNum());
     String physicalID = storageDir+pagenum+".page";
    
     try
     {
        File file = new File(physicalID);
        if (file.exists())
          file.delete();
     }
     catch(Exception e)
     {
        e.toString();
     }     
  }  
  
  public void cleanBMDirectory()
  {
     String path = storageDir;
    
     try
     {
        File dir = new File(path);
        if (dir.isDirectory())
        {
           String[] list = dir.list();
           for (int i=0; i<list.length; i++)
           {
              File file = new File(dir+"\\"+list[i]);
              file.delete();
           }
        }     
     }
     catch(Exception e)
     {
        e.toString();
     }     
  }
  
  public String loadXMLDoc(String txid,ThXMLDoc xmldoc, String fname, 
                           String xmlname, ThSystem sys)
  {     
     Properties prop = sys.getProperties();
     try
     {
        sys.out("Opening file:  "+fname);
        DataInputStream in = new DataInputStream(
                              new BufferedInputStream(
                                new FileInputStream(fname)));
        
        xmldoc.load(txid, in, xmlname, sys);
        in.close();
     }
     catch(IOException e)
     {
        sys.out(e.toString());
        sys.out("Closing file:  "+fname);  
        return (String)prop.get("OPEN_FILE_ERROR"); 
     }     
     
     return (String)prop.get("EC0"); 
  }
}