package cs297.xmldb.src.sm;
import java.io.*;
import java.util.*;
import java.lang.*;
import cs297.xmldb.src.cm.*;
import cs297.xmldb.src.server.*;

public class ThTransactionMgr implements Serializable
{ 
  Hashtable transactionTable;
  String lastCheckPoint;
  String path = "";
  
  public ThTransactionMgr(Properties properties)
  {
     transactionTable = new Hashtable();
     path = (String) properties.getProperty("transactionTable");
  }
  
 /**
  * Add new Transaction into transaction table
  */
  public int add(String id)
  {
      if (!transactionTable.containsKey(id))
         transactionTable.put(id, new ThTransaction(id));
      
      return 0; //success
  }
  
  public ThTransaction get(String id)
  {
     return (ThTransaction)transactionTable.get(id);
  }
  
  public int addUndoLSN(String txid, String lsn)
  {
     if (!transactionTable.containsKey(txid))
        transactionTable.put(txid, new ThTransaction(txid));
    
     ((ThTransaction)transactionTable.get(txid)).addUndoLSN(lsn);
    
     return 0;
  }
  
  /**
   * need to savePoint to all trans in the table
   */
  public void checkPoint(String txid)
  {
     ((ThTransaction)transactionTable.get(txid)).savePoint();
  }
  
  public void savePoint(String txid)
  {
     ((ThTransaction)transactionTable.get(txid)).savePoint();
  }
  
  public void commit(String txid)
  {
     ((ThTransaction)transactionTable.get(txid)).commit();
  }
  
  public void removeTransactions()
  {
     transactionTable = new Hashtable();
  }
  
  public Enumeration keys()
  {
     return transactionTable.keys();
  }
  
  public void archive()
  {
     String txid;
     ThTransaction tx;
     for (Enumeration e=transactionTable.keys(); e.hasMoreElements();)
     {
        txid = (String) e.nextElement();
        tx = (ThTransaction) transactionTable.get(txid);
        tx.archive();
     }
  }
  
  public String getLastLSN(String txid, String currlsn)
  {
     ThTransaction tx = (ThTransaction) transactionTable.get(txid);
    
     return tx.getLastLSN(currlsn);
  }
}