package cs297.xmldb.src.utils;
import java.util.*;
import java.math.*;
import java.io.*;
import cs297.xmldb.src.server.*;
import cs297.xmldb.src.cm.*;
import cs297.xmldb.src.sm.*;
import cs297.xmldb.src.bm.*;

/**
 This class is used as an experimental input generator.
 It generates operations such as insert, update randomly.
 The data for the node it generating should be specified in
 the filel dbsystem.properties file.
 @Date:   Spring 2004
 @Author: Thien An Nguyen
 */
public class ThRandomTestCreator
{      
   public ThRandomTestCreator()
   {
     try
     {     
        /* Initialization */
        Random rand = new Random();
        Properties prop = new Properties();
        prop.load(new FileInputStream("c://an//cs297//xmldb//dbsystem.properties"));        
        int num = Integer.parseInt(prop.getProperty("numberOfNodes"));        
        String para = prop.getProperty("paragraph");
        String outfile = prop.getProperty("randomOutFile");        
        int delletecount = Integer.parseInt(prop.getProperty("deleteCount"));
        int insertweight = Integer.parseInt(prop.getProperty("insertWeight"));
        int updateweight = Integer.parseInt(prop.getProperty("updateWeight"));
        
        /* Open Output file */
        DataOutputStream outStream = new DataOutputStream(
                                      new BufferedOutputStream(
                                       new FileOutputStream(outfile)));  
        
        /* Insert some DDL and Util statements first */
        outStream.writeBytes("T1 CREATE DATABASE DB1DB;\r\n"
                           + "T1 CREATE XMLDOC XML1DOC IN DB1DB;\r\n\r\n"
                           + "T1 LOAD "
                           + "\"c://an//cs297//xmldb//src//sm//input//test1.xml\""
                           + " INTO XML1DOC;\r\n\r\n"
                           + "T1 COMMIT;\r\n\r\n"
                           + "T1 ARCHIVE DB1DB;\r\n");
        outStream.writeBytes("\r\n");
        
        /* Generating operations */
        int possi;
        for (int i = 0; i < num; i++)
        {
           possi = rand.nextInt(10);
           if (possi < insertweight)  
           {    /* insert statement */
              outStream.writeBytes("T1 INSERT INTO XML1DOC PATH(\"/G/G["
                                 +(i%10+1)
                                 +"]/L\") "
                                 + "VALUES(\"<L>"
                                 + i
                                 + para
                                 + "</L>\");\r\n");
           } 
           else
           {   /* update statement */
              outStream.writeBytes("T1 UPDATE XML1DOC SET VALUE(\"<L>"
                                 + i
                                 + para
                                 + "</L>\")"
                                 + " WHERE PATH(\"/G/G[1]/L[3]\");"
                                 + "\r\n");
           }        
          
           outStream.writeBytes("\r\n");
        }    
        
        for (int i = 1; i <= delletecount; i++)
            outStream.writeBytes("T1 DELETE FROM XML1DOC WHERE PATH(\"/G/G[6]\");"
                               + "\r\n\r\n");
        
        /* insert some close statement */
 //       outStream.writeBytes("T1 printTree(XML1DOC);\r\n\r\n");
        
        /* crash system */
        outStream.writeBytes("T1 CRASH;\r\n\r\n");
 //       outStream.writeBytes("T1 printTree(XML1DOC);\r\n\r\n");
        
        outStream.writeBytes("T1 DROP XMLDOC XML1DOC;\r\n\r\n");
        outStream.writeBytes("T1 DROP DATABASE DB1DB;\r\n\r\n");
        outStream.flush();
     }
     catch(Exception e) {
        System.out.println(e.toString());
     }  
   }
   
   public static void main(String[] args)
   {
      ThRandomTestCreator ran = new ThRandomTestCreator();
   }   
}