package cs297.xmldb.src.utils;

import java.util.*;
import java.io.*;

/**
 * This object is used by Server to contain information client need
 * and is used by client to display the information.
 *
 * Creation date: (10/16/2001 1:26:31 AM)
 * @author: Thien An Nguyen
 */
public class ThTime implements Serializable{
	public final static String TEST = "000";
	public final static String FAILED = "101";
	public final static String CHECKED = "111";
	public final static int PORT = 1500;
	public final static int TIME_OUT = 500;
	public final static String DAYs[] = {"Sunday", "Monday", "Tuesday", "Wednesday", 
										"Thursday", "Friday", "Saturday"};
	public final static String MONTHs[] = {"January", "February", "March", "April", "May", 
										"June", "July", "August", "Septempber", 
										"October", "November", "December"};

	private String interZone;
	private GregorianCalendar calendar;
	/**
	* construction
	*/
	public ThTime(GregorianCalendar c, String tz)
	{
		calendar = c;
		interZone = tz;
	}
	/**
	* returns the current date in the form of day, month, date, and year
	*/
	public String getDate()
	{
		String result = "";
		int dayofwk = calendar.get(Calendar.DAY_OF_WEEK);
		int mon = calendar.get(Calendar.MONTH);
		
		result += DAYs[dayofwk-1] + ", ";
		result += MONTHs[mon] + " ";
		result += calendar.get(Calendar.DATE) + ", ";
		result += calendar.get(Calendar.YEAR);
		
		return result;
	}
	/**
	* returns the international timezone string
	*/
	public String getInterZone()
	{
		return interZone;
	}
	/**
	* returns GregorianCalendar from this object
	*/
	public GregorianCalendar getLocalCalendar()
	{
		return calendar;
	}
	/**
	* returns the current time in the form hour:minute ampm
	*/
	public String getTime()
	{
		int hourAP;
		int minute;
		String ampm;
		String result = "";
		int hour24 = calendar.get(Calendar.HOUR_OF_DAY);
		
		if (hour24 > 12){
			hourAP = hour24 - 12;
			ampm = " PM";
		}else if (hour24 == 12){
			hourAP = hour24;
			ampm = " PM";
		}else{
			hourAP = hour24;
			ampm = " AM";
		}

		if (hourAP < 10){
			result += "0";
		}
		result += hourAP;
		result += ":";
		
		minute = calendar.get(Calendar.MINUTE);
		if (minute < 10){
			result += "0";
		}
		result += minute+ampm;
		
		return result;
	}
	public static String myUTCFormat(GregorianCalendar cal)
	{
		int hourAP;
		int minute;
		String ampm;
		String result = "";
		int hour24 = cal.get(Calendar.HOUR_OF_DAY);
		int dayofwk = cal.get(Calendar.DAY_OF_WEEK);
		int mon = cal.get(Calendar.MONTH);
		
		if (hour24 > 12){
			hourAP = hour24 - 12;
			ampm = " PM";
		}else if (hour24 == 12){
			hourAP = hour24;
			ampm = " PM";
		}else{
			hourAP = hour24;
			ampm = " AM";
		}

		if (hourAP < 10){
			result += "0";
		}
		result += hourAP;
		result += ":";
		
		minute = cal.get(Calendar.MINUTE);
		if (minute < 10){
			result += "0";
		}
		result += minute+ampm + " on ";		
		result += DAYs[dayofwk-1] + ", ";
		result += MONTHs[mon] + " ";
		result += cal.get(Calendar.DATE) + ", ";
		result += cal.get(Calendar.YEAR);
		
		return result;
	}
	/**
	* set calendar's time
	*/
	public void setTime(Date d)
	{
		calendar.setTime(d);
	}
}
