package cs297.xmldb.src.utils;
import java.util.*;
import java.lang.*;
import java.io.*;
import cs297.xmldb.src.server.*;
import cs297.xmldb.src.cm.*;
import cs297.xmldb.src.sm.*;
import cs297.xmldb.src.bm.*;

/**
 * Purpose: Unit Test execution of statements in DDL/DML plan
 * Date:   Spring 2004
 * Author: Thien An Nguyen
 */
public class ThVerifyResult
{   
   String veriName,   
          outputName,
          resultName;
   DataInputStream veriInput,
                   outputInput;
   DataOutputStream resultOutput;
   Properties proP;
   public ThVerifyResult(Properties prop)
   {
      veriName = (String) prop.get("verifyFile");
      outputName = (String) prop.get("outputFile");
      resultName = (String) prop.get("resultFile");
      proP = prop;
      try
      {    
         veriInput = new DataInputStream(
                     new BufferedInputStream(
                     new FileInputStream(veriName)));  
         outputInput = new DataInputStream(
                       new BufferedInputStream(
                       new FileInputStream(outputName)));  
         resultOutput = new DataOutputStream(
                        new BufferedOutputStream(
                        new FileOutputStream(resultName)));
      }catch (IOException e){
         e.printStackTrace();
      }
   }
   
   public String getResult()
   {
      System.out.println("Verifying................");
      String veriline,
             outputline;
      int rc = 0;
      try{      
         while ((veriline = veriInput.readLine())!=null)
         {
            while((outputline = outputInput.readLine())!=null)
            {
               if (veriline.equals(outputline))
               {
                  rc = 0;
                  resultOutput.writeBytes(veriline+"\r\n");
                  break;
               }
               else
                  rc = -1;
            }
 
            if (rc < 0)
            {
               resultOutput.writeBytes("===>Can't find the following " 
                  + "line in output file: " + outputName + "\r\n");
               resultOutput.writeBytes(veriline+"\r\n");
               resultOutput.flush();
               
               return (String) proP.get("EC2");
            }
         }
     }catch (Exception e){
        return e.toString();
     }
      
     return (String) proP.get("EC0");
   }
}